/****************************************************************************
                              Copyright (c) 2010
                            Lantiq Deutschland GmbH
                     Am Campeon 3; 85579 Neubiberg, Germany

  For licensing information, see the file 'LICENSE' in the root folder of
  this software module.

 *****************************************************************************
   \file ifx_ethsw_core_platform.h
   \remarks Platform dependancy Core Layer header file, for Infineon Ethernet
            switch drivers
 *****************************************************************************/
#ifndef _IFX_ETHSW_CORE_PLATFORM_H_
#define _IFX_ETHSW_CORE_PLATFORM_H_

#include "ifx_types.h"

/* ============================= */
/* Local Macros & Definitions    */
/* ============================= */

#define VR9_RCU_BASE_ADDR                 (0xBF203000)
#define VR9_INT_BASE_ADDR                 (0xBF107000)
#define VR9_SWITCH_BASE_ADDR              (0xBE108000)
#define VR9_REG_ACCESS(addr)              *((volatile IFX_int32_t *)(addr))

#define VR9_CHIP_ID_MAGIC_NUMBER          (0x101C0083)

/* Chip Identification Register  */
#define MPS_CHIPID								(VR9_INT_BASE_ADDR + 0x344)

/* GPHY01 MDIO Address Register  */
#define GFMDIO_ADD								(VR9_RCU_BASE_ADDR + 0x44)

/* PHY Address Register PORT 5  */
#define PHY_ADDR_5								(VR9_SWITCH_BASE_ADDR + (0xC50 * 4))
/* PHY Address Register PORT 4  */
#define PHY_ADDR_4								(VR9_SWITCH_BASE_ADDR + (0xC51 * 4))
/* PHY Address Register PORT 3  */
#define PHY_ADDR_3								(VR9_SWITCH_BASE_ADDR + (0xC52 * 4))
/* PHY Address Register PORT 2  */
#define PHY_ADDR_2								(VR9_SWITCH_BASE_ADDR + (0xC53 * 4))

/* Transmit and Receive Buffer Control Register */
#define MAC_PDI_CTRL_6                    (VR9_SWITCH_BASE_ADDR + (0x951 * 4))

/* Transmit and Receive Buffer Control Register */
#define PMAC_RX_IPG                       (VR9_SWITCH_BASE_ADDR + (0xCCB * 4))

/**********************/
/* Function Prototype */
/**********************/

IFX_int32_t platform_device_reset_trigger(IFX_void_t);
IFX_int32_t platform_device_reset_release(IFX_void_t);
IFX_int32_t platform_device_init(IFX_void_t);

#endif    /* _IFX_ETHSW_CORE_PLATFORM_H_ */
